<?xml version="1.0" encoding="GB2312"?>
<!DOCTYPE stylesheet [
<!ENTITY source "yaxx">
<!ENTITY target "cyaxx">
<!ENTITY source-ns "urn:YAcc-Xml-eXtension">
<!ENTITY target-ns "urn:cyaxx">
<!ENTITY diction "'ansic-dictionary.xml'">
]>
<stylesheet version="1.0" 
    xmlns="http://www.w3.org/1999/XSL/Transform" 
    xmlns:yaxx="&source-ns;" 
    xmlns:cyaxx="&target-ns;">
	<output method="xml" indent="yes"/>
	<template match="/">
		<apply-templates select="child::&source;:*"/>
	</template>
	<template match="&source;:*">
		<variable name="node" select="."/>
		<variable name="tag" select="local-name()"/>
		<for-each select="document(&diction;)/dictionary/entry[@type='element']">
			<if test="$tag=./&source;">
				<element name="&target;:{./&target;}">
					<call-template name="translate-element">
						<with-param name="node" select="$node"/>
					</call-template>
				</element>
			</if>
		</for-each>
		<if test="count(document(&diction;)/dictionary/entry[@type='element' and ./&source; = $tag])=0">
			<element name="&target;:{$tag}">
				<call-template name="translate-element">
					<with-param name="node" select="$node"/>
				</call-template>
			</element>
		</if>
	</template>
	<template name="translate-element">
		<param name="node"/>
		<for-each select="$node/@*">
			<variable name="attrib" select="local-name()"/>
			<variable name="attrnode" select="."/>
			<for-each select="document(&diction;)/dictionary/entry[@type='attribute']">
				<if test="$attrib=./&source;">
					<attribute name="{./&target;}">
						<call-template name="filter">
							<with-param name="attrib" select="$attrnode"/>
						</call-template>
					</attribute>
				</if>
			</for-each>
			<if test="count(document(&diction;)/dictionary/entry[@type='attribute' and ./&source;=$attrib])=0">
			   <if test="$attrib!='xmlns'">
				<attribute name="{$attrib}">
					<call-template name="filter">
						<with-param name="attrib" select="$attrnode"/>
					</call-template>
				</attribute>
			   </if>
			</if>
		</for-each>
        <value-of select="$node/text()"/>
		<for-each select="$node/child::&source;:*">
			<apply-templates select="."/>
		</for-each>
	</template>
	<template name="filter">
		<param name="attrib"/>
		<call-template name="filter-string">
			<with-param name="str" select="$attrib"/>
		</call-template>
	</template>
	<template name="filter-string">
		<param name="str"/>
		<for-each select="document(&diction;)/dictionary/entry[@type='axis']">
			<variable name="axis" select="concat(./&source;, '::')"/>
			<variable name="target_axis" select="concat(./&target;, '::')"/>
			<if test="contains($str,$axis) and starts-with($str, $axis)">
				<call-template name="filter-string">
					<with-param name="str" select="concat($target_axis,substring-after($str,$axis))"/>
				</call-template>
			</if>
		</for-each>
		<for-each select="document(&diction;)/dictionary/entry[@type='function']">
			<variable name="function" select="concat(./&source;, '(')"/>
			<variable name="target_func" select="concat(./&target;, '(')"/>
			<if test="contains($str,$function) and starts-with($str, $function)">
				<variable name="s2" select="substring-after($str, $function)"/>				
				<call-template name="filter-string">
					<with-param name="str" select="concat($target_func,$s2)"/>
				</call-template>
			</if>
		</for-each>
		<if test="count(document(&diction;)/dictionary/entry[@type='axis' and contains($str,concat(./&source;, '::')) or @type='function' and contains($str, concat(./&source;,'('))]) = 0 ">
			<value-of select="$str"/>
		</if>
	</template>
</stylesheet>
